<%#-- copyright
Nepenthes is a free and open project management software.
Copyright (C) 2024 The Nirvati developers

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

Nepenthes is a fork of OpenProject. The copyright follows:

Copyright (C) 2012-2024 the OpenProject GmbH

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
Copyright (C) 2006-2013 Jean-Philippe Lang
Copyright (C) 2010-2013 the ChiliProject Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

See COPYRIGHT and LICENSE files for more details.

++#%>

<% breadcrumb_paths(
     link_to(t(:label_forum_plural), project_forums_path(@project)),
     link_to(h(@forum.name), project_forum_path(@project, @forum)))
%>

<% content_controller 'forum-messages',
                      dynamic: true %>

<% title avatar(@topic.author) + h(@topic.subject) %>
<%= toolbar title: title do %>
  <li class="toolbar-item hidden-for-tablet">
    <%= watcher_link(@topic, User.current) %>
  </li>
  <li class="toolbar-item hidden-for-tablet">
    <% if !@topic.locked? && authorize_for('messages', 'reply') %>
      <%= link_to(
            { action: 'quote', id: @topic },
            data: { 'action': 'forum-messages#quote' },
            class: 'boards--quote-button button'
          ) do %>
        <%= op_icon('button--icon icon-quote') %>
        <span class="button--text"><%= t(:button_quote) %></span>
      <% end %>
    <% end %>
  </li>
  <li class="toolbar-item">
    <% if @message.editable_by?(User.current) %>
      <%= link_to(edit_topic_path(@topic), accesskey: accesskey(:edit), class: 'button') do %>
        <%= op_icon('button--icon icon-edit') %>
        <span class="button--text"><%= t(:button_edit) %></span>
      <% end %>
    <% end %>
  </li>
  <li class="toolbar-item">
    <% if @message.destroyable_by?(User.current) %>
      <%= link_to(topic_path(@topic), method: :delete, data: { confirm: t(:text_are_you_sure) }, class: 'button') do %>
        <%= op_icon('button--icon icon-delete') %>
        <span class="button--text"><%= t(:button_delete) %></span>
      <% end %>
    <% end %>
  </li>
<% end %>

<div class="forum-message">
  <p class="author additional-information"><%= authoring @topic.created_at, @topic.author %></p>
  <div class="wiki op-uc-container">
    <%= format_text(@topic.content, object: @topic, attachments: @topic.attachments) %>
  </div>

  <% resource = message_attachment_representer(@topic) %>
  <%= list_attachments(resource) %>

</div>
<br/>

<div class="forum-message--comments comments">
  <% unless @replies.empty? %>
    <h3 class="icon-context icon-quote"><%= t(:label_reply_plural) %> (<%= @replies.count %>)</h3>
    <% @replies.each do |message| %>
      <div class="comment" id="<%= "message-#{message.id}" %>">
        <div class="contextual">
          <%= link_to(icon_wrapper('icon-context icon-quote', t(:button_quote)),
                      { action: 'quote', id: message },
                      title: t(:button_quote),
                      class: 'boards--quote-button no-decoration-on-hover',
                      data: { 'action': 'forum-messages#quote' },
                      alt: t(:button_quote)) if !@topic.locked? && authorize_for('messages', 'reply')

          %>
          <%= link_to(icon_wrapper('icon-context icon-edit', t(:button_edit)),
                      { action: 'edit', id: message },
                      title: t(:button_edit),
                      class: 'no-decoration-on-hover',
                      alt: t(:button_edit)) if message.editable_by?(User.current) %>
          <%= link_to(icon_wrapper('icon-context icon-delete', t(:button_delete)),
                      { action: 'destroy', id: message },
                      method: :delete,
                      data: { confirm: t(:text_are_you_sure) },
                      title: t(:button_delete),
                      class: 'no-decoration-on-hover',
                      alt: t(:button_delete)) if message.destroyable_by?(User.current) %>
        </div>
        <h4 class="author additional-information">
          <%= avatar(message.author) %>
          <%= link_to h(message.subject), topic_path(@topic,
                                                     r: message,
                                                     page: @offset,
                                                     anchor: "message-#{message.id}") %>
          -
          <%= authoring message.created_at, message.author %>
        </h4>
        <div class="wiki op-uc-container">
          <%= format_text message, :content, attachments: message.attachments %>
        </div>
        <% if message.attachments.any? %>
          <% resource = message_attachment_representer(message) %>
          <%= list_attachments(resource) %>
        <% end %>
      </div>
    <% end %>
    <%= pagination_links_full @replies, per_page_links: false %>
  <% end %>

  <% if !@topic.locked? && authorize_for('messages', 'reply') %>
    <div id="reply" data-forum-messages-target="reply">

      <hr class="form--separator"/>

      <%= labelled_tabular_form_for @reply,
                                    as: :reply,
                                    url: reply_to_topic_path(@topic),
                                    html: { multipart: true,
                                            id: 'message-form',
                                            class: 'form' } do |f| %>
        <%= render partial: 'form', locals: { f: f, replying: true } %>

        <hr class="form--separator"/>

        <%= f.button t(:button_submit), class: 'button -primary -primary -with-icon icon-checkmark' %>
      <% end %>
      <div id="preview"></div>
    </div>
  <% end %>
</div>

<% html_title h(@topic.subject) %>
